
function FontIconView(view)
  import "java.io.File"
  import "android.graphics.Typeface"
  local path = File(activity.getLuaDir().."/FontIcons.ttf")
  local font = Typeface.createFromFile(path)

  local FontIconView=loadlayout{
    TextView,
    id=view.id,
    Typeface=font,
    text=view.icon,
    gravity="center",
    TextSize=view.size,
    TextColor=view.color,
    contentDescription=view.title,
  }
  if view.title ~= nil then
    FontIconView.onLongClick=function(view)
      print(view.contentDescription)
      return true
    end
  end
  return function()
    return FontIconView
  end
end
