require "import"
import "android.os.Environment"
import "android.widget.TextView"
import "android.widget.LinearLayout"



Player = MediaPlayer()
statusBarColor="#202125";
colorPrimary="#202125";
colorAccent="#007DFF";
SDCARD_PATH = tostring(Environment.getExternalStorageDirectory())
APP_PACKAGENAME = activity.getPackageName()
APP_CACHEPATH = tostring(activity.getExternalCacheDir())



function _run(m,s)
  function run()
    s=s+1
    if(s==60) then
      m=m+1
      s=0
    end
    call("UpdateTime",m,s)
  end
end



function PlayerMusic(path)
  Player.reset()
  .setDataSource(path)
  .prepare()
  .start()
  .setOnPreparedListener({
    onPrepared=function()
      local max = Player.getDuration()
      id_Progress.setMax(max)
      local time = FormatTime(max)
      id_endTime.setText(time)
      id_startTime.setText("00:00")

      if t ~= nil then
        t.Enabled=false
        t.stop()
        t= nil
      end

      t=timer(_run,0,1000,0,0)
      t.Enabled=true
    end})

end



function UpdateTime(m,s)
  if m<10 then m="0"..m end
  if s<10 then s="0"..s end
  id_startTime.setText(m..":"..s)
  id_Progress.setProgress(Player.getCurrentPosition())
end

function FormatTime(time)
  local min,sec=0,0
  sec=math.floor(time/1000)
  if(sec>60) then
    min=math.floor(sec/60)
    sec=math.floor(sec%60)
  end
  if min<10 then min="0"..min end
  if sec<10 then sec="0"..sec end
  return min..":"..sec
end


function setTime(time)
  local min,sec=0,0
  sec=math.floor(time/1000)
  if(sec>60) then
    min=math.floor(sec/60)
    sec=math.floor(sec%60)
  end

  return min,sec
end



function Toast(str)
  local toast = luajava.bindClass("android.widget.Toast")
  toast.makeText(activity, tostring(str),toast.LENGTH_SHORT).show()
end


ItemLayout = {
  LinearLayout;
  layout_height="fill";
  layout_width="fill";
  orientation="vertical";
  {
    LinearLayout;
    layout_height="60dp";
    layout_width="fill";
    orientation="vertical";
    gravity="center_vertical";
    {
      TextView;
      id="title";
      textColor="0xFFFFFFFF";
      layout_marginLeft="16dp";
    };
    {
      TextView;
      id="path";
      Visibility=8,
      layout_marginLeft="16dp";
    };
  };
};



function QueryAllMusic(source)
  local MusicTable = {album = {},artist = {},duration = {},filepath = {},filename = {},songname = {},}
  import "android.provider.MediaStore"
  local cursor =this.getContentResolver().query(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, null,null,null,MediaStore.Audio.Media.DEFAULT_SORT_ORDER)
  if cursor.moveToFirst() then
    while cursor.moveToNext() do
      local ALBUM = cursor.getString(cursor.getColumnIndex(MediaStore.Audio.Media.ALBUM))--专辑
      local ARTIST = cursor.getString(cursor.getColumnIndex(MediaStore.Audio.Media.ARTIST))--歌手
      local DURATION = cursor.getLong(cursor.getColumnIndex(MediaStore.Audio.Media.DURATION))--长度
      local TITLE = cursor.getString(cursor.getColumnIndex(MediaStore.Audio.Media.TITLE))--歌名
      local DATA = cursor.getString(cursor.getColumnIndex(MediaStore.Audio.Media.DATA))--文件路径
      local DISPLAY_NAME = cursor.getString(cursor.getColumnIndex(MediaStore.Audio.Media.DISPLAY_NAME))--文件名称
      if ARTIST=="<unknown>" then
        ARTIST=""
      end
      if DURATION>30000 then
        table.insert(MusicTable.album,ALBUM)
        table.insert(MusicTable.filepath,DATA)
        table.insert(MusicTable.artist,ARTIST)
        table.insert(MusicTable.songname,TITLE)
        table.insert(MusicTable.duration,DURATION)
        table.insert(MusicTable.filename,DISPLAY_NAME)
      end

    end
  end
  return MusicTable
end



function LoadMusicList(content)
  adp=LuaAdapter(activity,ItemLayout)
end


import "android.graphics.drawable.BitmapDrawable"
isMax=false
function Timer_Dialog()
  if isMax==false then
    isMax=true
    id_page.showPage(0)
    id_timer.setImageDrawable(BitmapDrawable(loadbitmap("music.png")))
   else
    isMax=false
    id_page.showPage(2)
    id_timer.setImageDrawable(BitmapDrawable(loadbitmap("ic_list.png")))
  end
end


