require "import"
import "java.io.File"
import "android.os.Build"
import "java.lang.String"
import "android.view.View"
import "java.io.FileReader"
import "java.io.FileWriter"
import "java.util.ArrayList"
import "android.view.KeyEvent"
import "java.io.BufferedWriter"
import "java.io.BufferedReader"
import "android.graphics.Color"
import "android.widget.EditText"
import "android.app.AlertDialog"
import "android.media.MediaPlayer"
import "android.app.ProgressDialog"
import "android.view.WindowManager"
import "android.content.DialogInterface"
import "android.graphics.drawable.ColorDrawable"


import "Module"
import "FontIconView"
import "android.widget.Button"
import "android.widget.Spinner"
import "android.widget.SeekBar"
import "android.widget.PageView"
import "android.widget.TextView"
import "android.widget.ListView"
import "android.widget.CardView"
import "android.widget.ImageView"
import "android.widget.ArrayAdapter"
import "android.widget.RippleLayout"
import "android.widget.LinearLayout"
import "android.widget.RelativeLayout"

activity.ActionBar.setElevation(0)
activity.setRequestedOrientation(1)


activity.setContentView(loadlayout"MainLayout")
activity.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN)
activity.ActionBar.setBackgroundDrawable(ColorDrawable(Color.parseColor(colorPrimary)))
if Build.VERSION.SDK_INT >= 21 then
  activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(Color.parseColor(statusBarColor))
end



LoadMusicList("离人愁")
local SongList = QueryAllMusic()
local int = activity.getSharedData("currentMusic")
if int ~= nil then
  activity.ActionBar.setSubtitle(tostring(SongList.artist[int]).." - "..tostring(SongList.songname[int]))
end




local adp = LuaAdapter(this,{},ItemLayout)
local songlist = SongList.filename
for i=1,#songlist do
  adp.add{title=SongList.artist[i]..""..songlist[i],path=tostring(i)}
end
id_listb.Adapter=adp







id_listb.onItemClick=function(view,item,int)
  local int = tointeger(item.Tag.path.Text)
  activity.ActionBar.setSubtitle(tostring(QueryAllMusic().artist[int]).." - "..tostring(SongList.songname[int]))
  activity.setSharedData("currentMusic",int)
  PlayerMusic(SongList.filepath[int])
  id_switch.setText("pause")
  id_page.showPage(2)
  id_timer.setImageDrawable(BitmapDrawable(loadbitmap("ic_list.png")))
end




local m = activity.getSharedData("mode")
if m == "one" then
  mode.setText("repeat_one")
 else
  mode.setText("repeat")
end



Player.setOnCompletionListener({
  onCompletion=function()
    id_Progress.setProgress(Player.getCurrentPosition())
    if t ~= nil then
      t.Enabled=false
      t.stop()
      t=nil
    end
    local int = activity.getSharedData("currentMusic")
    if activity.getSharedData("mode") == "one" then
      PlayerMusic(SongList.filepath[int])
     elseif activity.getSharedData("mode") == nil then
      on_next()
    end
  end})



function on_mode(v)
  if v.Text == "repeat_one" then
    Toast("Repeat 1 Off")
    v.setText("repeat")
    activity.setSharedData("mode",nil)
   elseif v.Text == "repeat" then
    Toast("Repeat 1 On")
    v.setText("repeat_one")
    activity.setSharedData("mode","one")
  end
end



function on_previous()
  local int = activity.getSharedData("currentMusic")
  if int ~= nil then
    activity.ActionBar.setSubtitle(tostring(SongList.artist[int-1]).." - "..tostring(SongList.songname[int-1]))
    activity.setSharedData("currentMusic",int-1)
    PlayerMusic(SongList.filepath[int-1])
    id_listb.setSelection(int-2)
    id_switch.setText("pause")
  end
end



function on_next()
  local int = activity.getSharedData("currentMusic")
  if int ~= nil then
    activity.ActionBar.setSubtitle(tostring(SongList.artist[int+1]).." - "..tostring(SongList.songname[int+1]))
    activity.setSharedData("currentMusic",int+1)
    PlayerMusic(SongList.filepath[int+1])
    id_listb.setSelection(int)
    id_switch.setText("pause")
  end
end



function on_switch(view)
  if Player.isPlaying() then
    view.setText("play_arrow")
    view.contentDescription="播放"
    Player.pause()
    if t ~= nil then
      t.Enabled=false
    end
    STATUS = true
   else
    if t ~= nil then
      Player.start()
      t.Enabled=true
      view.setText("pause")
      view.contentDescription="暂停"
    end
    local int = activity.getSharedData("currentMusic")
    if int ~= nil then
      id_listb.smoothScrollToPosition(int-1)
      if STATUS == nil then
        view.setText("pause")
        view.contentDescription="暂停"
        PlayerMusic(SongList.filepath[int])
        activity.ActionBar.setSubtitle(SongList.artist[int].." - "..SongList.songname[int])
      end
    end
  end
end



function onKeyDown(code)
  if code == 4 then
    if t ~= nil then
      t.stop()
      Player.stop()
      Player.release()
    end
  end
end



id_Progress.setOnSeekBarChangeListener({
  onStopTrackingTouch=function(bar)
    if Player.isPlaying() then
      local cur=bar.getProgress()
      local tt=FormatTime(cur)
      min,sec=setTime(cur)
      id_startTime.setText(tt)
      Player.seekTo(cur)
      if t~=nil then
        t.Enabled=false
        t.stop()
        t=nil
      end
      t=timer(_run,0,1000,min,sec)
      t.Enabled=true
    end

  end})
